<template>
  <div class="col-md-10 pt-4">
    <div class="table-responsive">
      <my-vuetable :apiUrl="apiUrl" :fields="fields" :tableName="tableName" :perPage="perPage">
        <template slot="actions-slot" slot-scope="props">
          <div class="d-flex">
            <user-detail-modal :user="selectedUser" @show="selectData(props.rowData)"></user-detail-modal>
            <user-edit-modal :user="selectedUser" @show="selectData(props.rowData)"></user-edit-modal>
            <delete-modal
              :data="{titleData: (selectedUser) ?selectedUser.name:''}"
              @deleteHandler="deleteUser()"
              @show="selectData(props.rowData)"
            ></delete-modal>
          </div>
        </template>
        <template slot="header-slot">
          <div class="col-6 col-md-3">
            <select class="form-control capsule" v-model="selectedChannel">
              <option @click="filterChannel('')" value>Show All Channel</option>
              <option v-for="channel in channelList" :value="channel.name" :key="channel.id">
                {{channel.name}}
                <!-- <img :src="asset(`images/channels/${props.rowData.channel.name}.png`)" style="width:50px"> -->
              </option>
            </select>
          </div>
        </template>
        <template slot="column1-slot" slot-scope="props">
          <img :src="asset(`images/channels/${props.rowData.channel.name}.png`)" style="width:25px">
        </template>
      </my-vuetable>
    </div>
  </div>
</template>

<script>
import MyVuetable from "@/components/table/MyVuetable";
import FieldDefs from "./FieldDefs";
import EventBus from "@/EventBus.js";
import UserDetailModal from "./modals/UserDetailModal";
import UserEditModal from "./modals/UserEditModal";
import DeleteModal from "@/components/general/modals/DeleteModal";

export default {
  data() {
    return {
      fields: FieldDefs,
      tableName: "Users",
      selectedUser: null,
      channelList: null,
      selectedChannel: "",
      perPage: 20
    };
  },
  computed: {
    apiUrl() {
      return this.baseUrl + `/api/${this.$store.getters.appId.hashed}/user`;
    }
  },
  components: {
    MyVuetable,
    UserDetailModal,
    UserEditModal,
    DeleteModal
  },
  created() {
    this.getChannel();
  },
  watch: {
    selectedChannel(val) {
      this.filterChannel(val);
    }
  },
  methods: {
    selectData(data) {
      this.selectedUser = data;
    },
    async deleteUser() {
      try {
        let response = await this.$axios.delete(
          process.env.MIX_APP_URL +
            `/api/${this.$store.getters.appId.hashed}/user/${
              this.selectedUser.id
            }`
        );
        this.$notify({
          group: "notif",
          type: "info",
          title: "Info",
          text: response.data.message
        });
        EventBus.$emit("hideModal");
        EventBus.$emit("refreshTable");
      } catch (error) {
        this.$notify({
          group: "error",
          type: "error",
          title: "Error",
          text: error.response.data.message
        });
      }
    },
    filterChannel(channelName) {
      EventBus.$emit("tableFilterSet", { filterText: channelName });
    },
    getChannel() {
      axios.get(this.$store.state.appUrl + "/api/channel").then(response => {
        return (this.channelList = response.data);
      });
    }
  }
};
</script>
<style lang="scss" scoped>
.dropdown-toggle::after {
  display: none;
}
select::-ms-expand {
  display: none !important;
}
select {
  border: none;
  -webkit-appearance: none !important;
  appearance: none !important;
}
</style>
